org.apache.storm.daemon

## Class Acker

- java.lang.Object
- - org.apache.storm.daemon.Acker

- All Implemented Interfaces:
    Serializable, IBolt

      public class Acker
      extends Object
      implements IBolt

  See Also:
    Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `ACKER_ACK_STREAM_ID`
    `static String` | `ACKER_COMPONENT_ID`
    `static String` | `ACKER_FAIL_STREAM_ID`
    `static String` | `ACKER_INIT_STREAM_ID`
    `static String` | `ACKER_RESET_TIMEOUT_STREAM_ID`
    `static int` | `TIMEOUT_BUCKET_NUM`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Acker()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `cleanup()` Called when an IBolt is going to be shutdown.
    `void` | `execute(Tuple input)` Process a single tuple of input.
    `void` | `prepare(Map<String,Object> topoConf, TopologyContext context, OutputCollector collector)` Called when a task for this component is initialized within a worker on the cluster.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### ACKER_COMPONENT_ID

          public static final String ACKER_COMPONENT_ID

      See Also:
        Constant Field Values

    - #### ACKER_INIT_STREAM_ID

          public static final String ACKER_INIT_STREAM_ID

      See Also:
        Constant Field Values

    - #### ACKER_ACK_STREAM_ID

          public static final String ACKER_ACK_STREAM_ID

      See Also:
        Constant Field Values

    - #### ACKER_FAIL_STREAM_ID

          public static final String ACKER_FAIL_STREAM_ID

      See Also:
        Constant Field Values

    - #### ACKER_RESET_TIMEOUT_STREAM_ID

          public static final String ACKER_RESET_TIMEOUT_STREAM_ID

      See Also:
        Constant Field Values

    - #### TIMEOUT_BUCKET_NUM

          public static final int TIMEOUT_BUCKET_NUM

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### Acker

          public Acker()

  - ### Method Detail

    - #### prepare

          public void prepare(Map<String,Object> topoConf,
                              TopologyContext context,
                              OutputCollector collector)

      Description copied from interface: `IBolt`

      Called when a task for this component is initialized within a worker on the cluster. It provides the bolt with the environment in which the bolt executes.

      This includes the:

      Specified by:
        `prepare` in interface `IBolt`
      Parameters:
        `topoConf` - The Storm configuration for this bolt. This is the configuration provided to the topology merged in with cluster configuration on this machine.
        `context` - This object can be used to get information about this task’s place within the topology, including the task id and component id of this task, input and output information, etc.
        `collector` - The collector is used to emit tuples from this bolt. Tuples can be emitted at any time, including the prepare and cleanup methods. The collector is thread-safe and should be saved as an instance variable of this bolt object.

    - #### execute

          public void execute(Tuple input)

      Description copied from interface: `IBolt`

      Process a single tuple of input. The Tuple object contains metadata on it about which component/stream/task it came from. The values of the Tuple can be accessed using Tuple#getValue. The IBolt does not have to process the Tuple immediately. It is perfectly fine to hang onto a tuple and process it later (for instance, to do an aggregation or join).

      Tuples should be emitted using the OutputCollector provided through the prepare method. It is required that all input tuples are acked or failed at some point using the OutputCollector. Otherwise, Storm will be unable to determine when tuples coming off the spouts have been completed.

      For the common case of acking an input tuple at the end of the execute method, see IBasicBolt which automates this.

      Specified by:
        `execute` in interface `IBolt`
      Parameters:
        `input` - The input tuple to be processed.

    - #### cleanup

          public void cleanup()

      Description copied from interface: `IBolt`

      Called when an IBolt is going to be shutdown. Storm will make a best-effort attempt to call this if the worker shutdown is orderly. The `Config.SUPERVISOR_WORKER_SHUTDOWN_SLEEP_SECS` setting controls how long orderly shutdown is allowed to take. There is no guarantee that cleanup will be called if shutdown is not orderly, or if the shutdown exceeds the time limit.

      The one context where cleanup is guaranteed to be called is when a topology is killed when running Storm in local mode.

      Specified by:
        `cleanup` in interface `IBolt`

Copyright © 2019 The Apache Software Foundation. All rights reserved.